package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.PixelBlocks;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import io.papermc.paper.event.player.PrePlayerAttackEntityEvent;
import org.bukkit.*;
import org.bukkit.entity.Interaction;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.event.player.PlayerInteractEvent;

import java.util.*;

import static eu.mhsl.minecraft.pixelblocks.PixelBlocks.plugin;

public class PlayerInteractListener implements Listener {
    @EventHandler
    static void onPlayerInteract(PlayerInteractEvent event) {
        if(event.getAction() == Action.RIGHT_CLICK_BLOCK && event.getClickedBlock() != null) {
            if(event.getClickedBlock().getType() == Material.GLASS) {
//                final WorldCreator worldCreator = new WorldCreator(plugin.getDataFolder().getPath()+"/"+event.getPlayer().getUniqueId());
//                worldCreator.type(WorldType.FLAT);
//
//                World newWorld = Bukkit.createWorld(worldCreator);
//
//                event.getPlayer().teleport(newWorld.getSpawnLocation());
            }
        }
    }

    @EventHandler
    static void onPlayerInteractEntity(PlayerInteractEntityEvent event) {
        if(event.getRightClicked() instanceof Interaction) {
            Location interactionLocation = event.getRightClicked().getLocation().add(0, PixelBlock.hitboxOffset+0.5, 0).toBlockLocation();
            interactionLocation.setYaw(0);
            interactionLocation.setPitch(0);

            UUID playerUID = event.getPlayer().getUniqueId();
            PixelBlock pixelBlock = PixelBlock.placedBlocks.stream()
                    .filter(block -> block.pixelBlockLocation.equals(interactionLocation))
                    .findFirst()
                    .orElseThrow();
            UUID blockOwner = pixelBlock.owner;

            if(playerUID.equals(blockOwner)) {
                pixelBlock.lastEntryLocation = event.getPlayer().getLocation();
                pixelBlock.lastEntryTime = System.currentTimeMillis();

                World blockWorld = Bukkit.getWorld(plugin.getDataFolder().getPath()+ "/" +pixelBlock.uuid);
                assert blockWorld != null;
                event.getPlayer().teleport(blockWorld.getSpawnLocation().clone().subtract(0.5, 0, 0.5));

//                Bukkit.getScheduler().cancelTask(pixelBlock.updateTaskID);
//                pixelBlock.updateTaskID = Bukkit.getScheduler().scheduleSyncRepeatingTask(
//                    PixelBlocks.plugin,
//                    pixelBlock::update,
//                    100L,
//                    100L
//                );
            } else {
                event.getPlayer().sendMessage("Dieser Block gehört nicht dir!");
            }
        }
    }

    @EventHandler
    static void onPlayerAttackEntity(PrePlayerAttackEntityEvent event) {
        if(event.getAttacked() instanceof Interaction) {
            Location blockLocation = event.getAttacked().getLocation().add(0, PixelBlock.hitboxOffset+0.5, 0).toBlockLocation();
            blockLocation.setYaw(0);
            blockLocation.setPitch(0);

            UUID playerUID = event.getPlayer().getUniqueId();
            PixelBlock pixelBlock = PixelBlock.placedBlocks.stream()
                    .filter(block -> block.pixelBlockLocation.equals(blockLocation))
                    .findFirst()
                    .orElseThrow();
            UUID blockOwner = pixelBlock.owner;

            if(playerUID.equals(blockOwner)) {
                Bukkit.getScheduler().runTask(PixelBlocks.plugin, pixelBlock::remove);
            } else {
                event.getPlayer().sendMessage("Dieser Block gehört nicht dir!");
            }

        }
    }
}
